from sqlalchemy import text
from app.lib import settings


async def index(scope, receive, send):
    if scope['state']['user']:
        conn = scope['state']['conn']
        conn.execute(text("update " + settings.DB_CRED['USERTAB'] +
                          " set session = '', expires=NULL where username = :user"),
                     {'user': scope['state']['user']['username']})
        conn.commit()
    scope['state']['session'] = None
    scope['state']['user'] = None

    await send({
        'type': 'http.response.start',
        'status': 302,
        'headers': [
            (b'Location', settings.APP_ROOT.encode('utf-8')),
            (b'Set-Cookie', 'sess=; path = /'.encode('utf-8'))
        ]
    })
    await send({
        'type': 'http.response.body',
        'body': ''
    })

