import uuid
from urllib.parse import parse_qs

from app.lib import util, settings


async def index(scope, receive, send):
    dom, body = util.create_page("Page Globals", scope)
    content = body.add_tag('div', {'class': 'content'})

    globs = util.get_page_globals(scope)
    if scope.get('method', '') == 'GET':
        globs['var1'] = 'default'

    if scope.get('method', '') == 'POST':
        parsed = parse_qs(await util.read_body(receive))
        if util.get_post_var(parsed, b'csrf') == globs.get('csrf'):
            form = util.get_post_var(parsed, b'form')
            if form == 'frm1':
                globs['var1'] = util.get_post_var(parsed, b'var1')
        else:
            util.msg(content, settings.TOKEN_MESSAGE, True)

    globs['csrf'] = str(uuid.uuid4())
    util.save_page_globals(scope, globs)

    content.add_tag('h2', {'style': 'text-align: center;'}, "Page Vars")
    content.add_tag('p', {}, 'var1 = ' + globs['var1'])
    frm = util.create_form(content, 'frm1', globs['csrf'])
    frm.add_tag('input', {'type': 'text', 'name': 'var1', 'value': globs['var1']}).add_tag('br')
    frm.add_tag('input', {'type': 'submit'})

    content.add_tag('br').add_tag('br')
    util.dump_scope(content, scope)

    await util.render_page(scope, send, dom)
